#ifndef		__MYSTD_H
#define		__MYSTD_H

#include	<stdio.h>
#include	<dos.h>
#include	<stdlib.h>
#include	<alloc.h>
#include	<string.h>
#include	<conio.h>
#include	<ctype.h>

#define		FALSE		0
#define		TRUE		1

#define		MEM_ERR		0
#define		OPEN_ERR	1
#define		WRITE_ERR	2
#define		READ_ERR	3

typedef		unsigned char	BYTE;
typedef		unsigned int	WORD;
typedef		unsigned long	DWORD;

void	_Error(int _mode,const char *_str);
char	far *MyStrdup(const char far *_src);
void	far *MyCalloc(DWORD _n,DWORD _size);
void	far *MyRealloc(char far *_src,DWORD _size);
FILE	*MyOpen(const char *_fname,const char *_mode);
void	MyRead(void *_dst,WORD _size,WORD _n,FILE *_stream,const char *_name);
void	MyWrite(const void *_src,WORD _size,WORD _n,FILE *_stream,const char *_name);
void	MyPutc(int _c,FILE *_stream,const char *_name);
int	MyGetc(FILE *_stream,const char *_name);
void	MyPutw(int _c,FILE *_stream,const char *_name);
WORD	GetAttrib(const char *_fname);
void	SetAttrib(const char *_fname,WORD _attrib);
DWORD	FileSize(FILE *_stream);
char	*fReadLine(FILE *ifile);
void	LargeRead(void *_dst,DWORD _size,FILE *_stream,const char *_name);
void	LargeWrite(void *_dst,DWORD _size,FILE *_stream,const char *_name);
int	ChoiceEng(int def);

void	_Error(int _mode,const char *_str){
	switch(_mode){
		case MEM_ERR :	printf("Memory allocation error.\n");
				break;
		case OPEN_ERR :	printf("Cannot open file %s\n",_str);
				break;
		case WRITE_ERR :
				printf("Write error on file %s\n",_str);
				break;
		case READ_ERR :	printf("Read error on file %s\n",_str);
				break;
	}
	exit(1);
}

char	far *MyStrdup(const char far *_src){
	char	far *result;
	if((result=farmalloc(strlen(_src)+1))==NULL) _Error(MEM_ERR,NULL);
	strcpy(result,_src);
	return result;
}

void	far *MyCalloc(DWORD _n,DWORD _size){
	void	far *result;
	if((result=farcalloc(_n,_size))==NULL) _Error(MEM_ERR,NULL);
	return result;
}

void	far *MyRealloc(char far *_src,DWORD _size){
	void	far *result;
	if((result=farrealloc(_src,_size))==NULL) _Error(MEM_ERR,NULL);
	return result;
}

FILE	*MyOpen(const char *_fname,const char *_mode){
	FILE	*result;
	if((result=fopen(_fname,_mode))==NULL) _Error(OPEN_ERR,_fname);
	return result;
}

void	MyRead(void *_dst,WORD _size,WORD _n,FILE *_stream,const char *_name){
	if(fread(_dst,_size,_n,_stream)!=_n) _Error(READ_ERR,_name);
}

void	MyWrite(const void *_src,WORD _size,WORD _n,FILE *_stream,const char *_name){
	if(fwrite(_src,_size,_n,_stream)!=_n) _Error(WRITE_ERR,_name);
}

void	MyPutc(int _c,FILE *_stream,const char *_name){
	if(putc(_c,_stream)==EOF) _Error(WRITE_ERR,_name);
}

int	MyGetc(FILE *_stream,const char *_name){
	int	result;
	if((result=getc(_stream))==EOF) _Error(READ_ERR,_name);
	return result;
}

void	MyPutw(int _c,FILE *_stream,const char *_name){
	if(putw(_c,_stream)==EOF) _Error(WRITE_ERR,_name);
}

WORD	GetAttrib(const char *_fname){
	__emit__(0x1e);		//push	ds
	_AX=0x4300;		//mov	ax,4300
	_DX=FP_OFF(_fname);	//lds	dx,_fname
	_DS=FP_SEG(_fname);
	__emit__(0xcd,0x21);	//int	21
	__emit__(0x1f);		//pop	ds
	return _CX;
}

void	SetAttrib(const char *_fname,WORD _attrib){
	__emit__(0x1e);		//push	ds
	_AX=0x4301;		//mov	ax,4301
	_CX=_attrib;		//mov	cx,_attrib
	_DX=FP_OFF(_fname);	//lds	dx,_fname
	_DS=FP_SEG(_fname);
	__emit__(0xcd,0x21);	//int	21
	__emit__(0x1f);		//pop	ds
}

DWORD	FileSize(FILE *_stream){
	DWORD	result;
	fpos_t	fp;
	fgetpos(_stream,&fp);
	fseek(_stream,0,SEEK_END);
	result=ftell(_stream);
	fsetpos(_stream,&fp);
	return result;
}

char	*fReadLine(FILE *ifile){
	char	*result,*s0a;
	result=MyCalloc(0x80,1);
	fgets(result,0x80,ifile);
	while(!(s0a=strchr(result,0x0a))){
		result=MyRealloc(result,strlen(result)+0x80);
		fgets(&result[strlen(result)],0x80,ifile);
	}
	*s0a=0x00;
	result=MyRealloc(result,strlen(result)+1);
	return result;
}

void	LargeRead(void *_dst,DWORD _size,FILE *_stream,const char *_name){
	DWORD	_cnt;
	BYTE huge *_target;
	_target=(void huge *)_dst;
	for(_cnt=0;_cnt<(_size&0xffff8000L);_cnt+=0x8000){
		MyRead(_target+_cnt,0x8000,1,_stream,_name);
	}
	if(_size&0x7fff) MyRead(_target+_cnt,_size&0x7fff,1,_stream,_name);
}

void	LargeWrite(void *_dst,DWORD _size,FILE *_stream,const char *_name){
	DWORD	_cnt;
	BYTE huge *_target;
	_target=(void huge *)_dst;
	for(_cnt=0;_cnt<(_size&0xffff8000L);_cnt+=0x8000){
		MyWrite(_target+_cnt,0x8000,1,_stream,_name);
	}
	if(_size&0x7fff) MyWrite(_target+_cnt,_size&0x7fff,1,_stream,_name);
}

int	ChoiceEng(int def){
	char	*mes,ch;
	mes=MyStrdup("[Y/N]?");
	mes[1+def*2]+=0x20;
	printf("%s",mes);
	do{
		ch=tolower(getch());
		if(!ch) getch();
	}while(!strchr("yn\r",ch));
	if(ch=='y') def=TRUE;
	if(ch=='n') def=FALSE;
	putchar(toupper(mes[3-def*2]));
	putchar('\n');
	return def;
}

#endif
